using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Text;

namespace Sample.Data
{
	[Serializable]
	public abstract class DataBase : INotifyPropertyChanged
	{
		public event PropertyChangedEventHandler PropertyChanged;

		protected virtual void OnPropertyChanged(string propertyName)
		{
			PropertyChangedEventHandler handler = PropertyChanged;

			if (handler != null)
			{
				handler(this, new PropertyChangedEventArgs(propertyName));
			}
		}
	}
}
